package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMACClass;
import cn.ibizlab.eam.core.eam_core.filter.EMACClassSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMACClass] 服务对象接口
 */
public interface IEMACClassService extends IService<EMACClass>{

    boolean create(EMACClass et) ;
    void createBatch(List<EMACClass> list) ;
    boolean update(EMACClass et) ;
    void updateBatch(List<EMACClass> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMACClass get(String key) ;
    EMACClass getDraft(EMACClass et) ;
    boolean checkKey(EMACClass et) ;
    boolean save(EMACClass et) ;
    void saveBatch(List<EMACClass> list) ;
    Page<EMACClass> searchDefault(EMACClassSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMACClass> getEmacclassByIds(List<String> ids) ;
    List<EMACClass> getEmacclassByEntities(List<EMACClass> entities) ;
}


